
[![Gem Version](https://badge.fury.io/rb/teuton.svg)](https://badge.fury.io/rb/teuton)

# TEUTON (version 2.1)

_Create Unit Test for your machines, and
test your infraestructure as code._

![logo](./docs/images/logo.png)

Teuton is an intrastructure test tool, useful for:
* Sysadmin teachers to evaluate students remote machines.
* Sysadmin apprentices to evaluate their learning process as a game.
* Professional sysadmin to monitor remote machines.

Teuton allow us:
* Write test units for real or virtual machines using simple DSL.
* Check compliance with requirements on remote machines.

# Documentation

* [Installation](https://github.com/teuton-software/teuton/tree/devel/docs/install/README.md)
    1. Install Ruby on your system.
    1. `gem install teuton`
* [Learning](https://github.com/teuton-software/teuton/tree/devel/docs/learn/README.md)
* [Commands](https://github.com/teuton-software/teuton/tree/devel/docs/commands/README.md)
* [Teuton language](https://github.com/teuton-software/teuton/tree/devel/docs/dsl/README.md)

# Features

* [Free Software License](https://github.com/teuton-software/teuton/tree/devel/LICENSE).
* Multiplatform.
* Remote machines only require SSH or Telnet service installed.
* Developed using ruby language.

# Contact

* **Email**: `teuton.software@protonmail.com`
* **Twitter**: `@SoftwareTeuton`
